#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <float.h>
#include <limits.h>

#include "u.h"
#include "m.h"
#include "cmd.h"
#include "g.h"
#include "fit.h"

static char rcsid[] = {"$Id: fitcmdlast.c,v 1.1.1.1 1997/07/10 17:59:59 kraemer Exp $"};

extern struct SFIT sFit;
/*
   --- Command processor for the FLAST command

   Copyright  (C) 1987-1997 M.Kraemer, D-64283 Darmstadt, Hoelgesstr. 16,
                             all rights reserved
   $Log: fitcmdlast.c,v $
   Revision 1.1.1.1  1997/07/10 17:59:59  kraemer
   revision for cvs

*/

void fitCmdLast(
                long *plKeep,
                long *plClear,
                long *plDel,
                long *plList,
                long *plNoConfirm,
                long *plDebug
               ) {
   int iRC = ERRFIT_BADADDR;
   char *pDbgMsg = __FILE__, *pMsg = pDbgMsg;
   unsigned long lFlag = FIT_NOMSG;

   int jf;


   if ( *plDebug ) lFlag |= FIT_DEBUG;
if ( lFlag & FIT_DEBUG ) fprintf( stderr, "<D> %s.....\n", pDbgMsg );


                                      /* delete all fit functions */
   if ( *plClear ) {

      if ( sFit.sFFB.nf <= 0 ) {
         iRC = ERRFIT_NOFUNCTION; goto gError;
      }
                                      /* confirm action */
      if ( !*plNoConfirm && _systso() )
         if ( ! _pyes( "Confirm" ) ) { iRC = 0; goto gError; }
                                      /*  */
      fitFctBlkFree( &sFit.sFFB, lFlag );
   }
                                      /* delete a single functions */
   if ( *plDel > 0 ) {

      if ( sFit.sFFB.nf <= 0 ) {
         iRC = ERRFIT_NOFUNCTION; goto gError;
      }
                                      /* confirm action */
      if ( !*plNoConfirm && _systso() )
         if ( ! _pyes( "Confirm" ) ) { iRC = 0; goto gError; }
                                      /*  */
      if ( iRC = fitFctBlkFctDelByNum( &sFit.sFFB, *plDel, lFlag ) ) goto gError;
   }
                                      /* keep last function (==append mode) */
   if ( *plKeep ) {
      sFit.sFFB.lStatus |= FITFCTBLK_KEEP;
   }
                                      /* list function characteristics */
   if ( *plList ) {
      int iParMin, iParMax;
      char *pcStr = NULL; int ncStr = 0, nStr;
      struct SFITFCT *psFF;


      if ( sFit.sFFB.nf <= 0 ) {
         iRC = ERRFIT_NOFUNCTION; goto gError;
      }
                                      /* count string length needed */
      for ( jf=0; jf<sFit.sFFB.nf; jf++ ) {
         nStr = strlen( sFit.sFFB.psFF[jf].pcName );
         ncStr = max( ncStr, nStr );
      }

      if ( ( pcStr = calloc(ncStr+40,sizeof(char)) ) == NULL ) {
         iRC = ERRFIT_SYS; goto gError;
      }

      sprintf( pcStr, "%6s %*.*s %14s",
                      "Number",
                      ncStr, ncStr, "Type",
                      "Parameters" );
      _prtcl( pcStr, CMDPRTCL_TERM | CMDPRTCL_FILE );
      iParMin = 1;
      psFF = sFit.sFFB.psFF;
      for ( jf=0; jf<sFit.sFFB.nf; jf++ ) {
         iParMax = iParMin + psFF->np - 1;
         sprintf( pcStr, "%6d %*.*s %6d..%6d",
                         jf+1,
                         ncStr, ncStr, psFF->pcName,
                         iParMin, iParMax );
         _prtcl( pcStr, CMDPRTCL_TERM | CMDPRTCL_FILE | CMDPRTCL_NOTIME );
         iParMin = iParMax + 1; psFF++;
      }
      free(pcStr); pcStr = NULL;

   }

   iRC = 0;
gError:;
   if ( (iRC < 0) /* && !(lFlag&FIT_NOMSG) */ ) {
      fitemsg( pMsg, iRC );
   }
if ( lFlag & FIT_DEBUG ) fprintf( stderr, "<D> %s done\n", pDbgMsg );
   return;
}
