#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <float.h>

#include "m.h"
#include "g.h"
#include "fit.h"
static char rcsid[] = {"$Id: fitlortz.c,v 1.1.1.1 1997/07/10 18:00:06 kraemer Exp $"};
/*
   --- Lorentzian peaks

   Copyright  (C) 1987-1997 M.Kraemer, D-64283 Darmstadt, Hoelgesstr. 16,
                             all rights reserved
  
   /mk/ 4/12/93 
   $Log: fitlortz.c,v $
   Revision 1.1.1.1  1997/07/10 18:00:06  kraemer
   revision for cvs


*/
#define DDPAR(ii,jj) ddPar[ (ii) * nX + (jj) ]
int fitLortz( void *pFct,
              double *dPar,                  /* function parameters */
              double *ddPar,                 /* switch=FITFCT_VAL:
                                              ddPar[nPar][0] = lower limit
                                              ddPar[nPar][1] = upper limit
                                              switch=FITFCT_DERIV:
                                              ddPar[nPar][nX] */
            double *dX, double *dY,
            int nPar, int nX, unsigned long lFlag ) {
   extern struct SFIT sFit;
   int ii, nPeak = nPar/3;
   int iRC = FITUSR_OK;


   switch( lFlag ) {
   case FITFCT_NPAR:      /* return # of parameters */
      return(nPar);
   break;
   case FITFCT_VAL:       /* return start values    */
      memset(  dPar, 0, nPar * sizeof(double) );
                          /* default FWHM to avoid zerodivide */
      for ( ii=0; ii<nPeak; ii++ ) {
         if ( dPar[ii*3+FITFCT_OFFSPEAKWIDTH] <= 0E0 ) dPar[ii*3+FITFCT_OFFSPEAKWIDTH] = 1E0;
      }
   break;
   case FITFCT_FCT:       /* return function values only */
   case FITFCT_DISP:      /* return function values only, for display */
      ddPar = NULL;
   case FITFCT_DERIV:     /* return function values & parameter derivatives  */
      for ( ii=0; ii<nPeak; ii++ ) {
         if ( dPar[ii*3+FITFCT_OFFSPEAKWIDTH] <= 0E0 ) {
            iRC = FITUSR_FCTFAILED;
            if ( lFlag == FITFCT_DERIV ) iRC = FITUSR_DERIVFAILED;
            return(iRC);
         }
      }
      vlortz( dX, 1, dPar, nPeak, dY, 1, ddPar, nX );
                          /* special: account for binsize of Y-values,
                                      because lorentzian is defined
                                      via an area parameter */
/*
      if ( (sFit.sBlk.dAvgBinsize > 0E0) &&
           (sFit.sBlk.lFitMode & FITBLK_HISTO) ) {
         vsmul ( dY, 1, sFit.sBlk.dAvgBinsize, dY, 1, nX );
         if ( ddPar ) {
            vsmul ( ddPar, 1, sFit.sBlk.dAvgBinsize, ddPar, 1, nX*nPar );
         }
      }
*/
   break;
   default: break;
   }
   return(iRC);
}
