#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <float.h>

#include "u.h"
#include "m.h"
#include "g.h"
#include "fit.h"

static char rcsid[] = {"$Id: fitusr.c,v 1.1.1.1 1997/07/10 18:00:07 kraemer Exp $"};

/*
   Interface to invoke external user function (OS-dependent).

   Copyright  (C) 1987-1997 M.Kraemer, D-64283 Darmstadt, Hoelgesstr. 16,
                             all rights reserved
  
   $Log: fitusr.c,v $
   Revision 1.1.1.1  1997/07/10 18:00:07  kraemer
   revision for cvs


*/

int fitusr(
            struct SFITFCT *psFF,
            double *dPar,                  /* function parameters */
            double *ddPar,                 /* switch=FITFCT_VAL:
                                              ddPar[nPar][0] = lower limit
                                              ddPar[nPar][1] = upper limit
                                              switch=FITFCT_DERIV:
                                              ddPar[nPar][nX] */
            double *dX, double *dY,
            int nPar, int nX,
            unsigned long lFlag ) {

   int (*eLoad)( void *, double *, double *, double *, double *,
                int, int, int );

   int iRC = ERRFIT_BADADDR;
   char cBuf[256];

   if ( ( eLoad = psFF -> eLoad ) == NULL ) goto gError;

#if defined(AMIGA)
   sprintf( cBuf, "%X %X %X %X %X %X %X %X %X %X",
            psFF, dPar, ddPar, dX, dY, &nPar, &nX, &lFlag, &iRC, &psFF->sUsr);
   callmain( (void *) eLoad, cBuf );
#else
   iRC = (*eLoad)( psFF, dPar, ddPar, dX, dY, nPar, nX, lFlag);
#endif

gError:;
   return(iRC);
}
